#include <fxlib.h>
#include <stdio.h>
#include <mathf.h>
#include <math.h>
#include "MonochromeLib.h"

#define ScreenWidth 64
#define ScreenHeight 128

#define MapWidth 30	// Nombre de colonnes de la map
#define MapHeight 30 // Nombre de lignes de la map

double PersoX = 2, PersoY = 2 ; // Coordonnées caméra
double CurrentTime = 0, OldTime = 0 ; // Temps de l'image actuelle et précédente
double VecteurDirX = -1, VecteurDirY = 0; // initialisation du vecteur directeur
double PlanX = 0, PlanY = 0.66;

void Affichage(int *map, int hauteur)
{
	for(int x = 0; x < ScreenWidth; x++) // Balayage horizontal de l'écran
    {
        int HauteurMur, DrawStart,DrawEnd,Color;

		//calcul de la position et de l'orientation du rayon
			double CameraX = 2 * x / ScreenWidth - 1; //Coordonner x dans l'espace de la camera
			double RayonPosX = PersoX;				 //Coordonner x de rayon dans l'espace
			double RayonPosY = PersoY;                 //Coordonner y de rayon dans l'espace
			double RayonDirX = VecteurDirX + PlanX * CameraX;
			double RayonDirY = VecteurDirY + PlanY * CameraX;
			
		//Dans quelle case de la carte, nous nous situons au debut
			int MapX = int(RayonPosX);
			int MapY = int(RayonPosY);


		double DistanceMurX; //Distance entre le joueur et 1e prochain mur vertical
		double DistanceMurY; //Distance entre le joueur et 1e prochain mur horizontal

		double Distance2MurX = sqrt(1 + (RayonDirY * RayonDirY) / (RayonDirX * RayonDirX)); //Distance entre deux murs verticaux
		double Distance2MurY = sqrt(1 + (RayonDirX * RayonDirX) / (RayonDirY * RayonDirY)); //Distance entre deux murs horizontaux
		double LongueurMur;



		int EtapeX; //si gauche x=-1, si droite x=+1
		int EtapeY; //si avance y=+1 et si recule y=-1

		int MurTouche = 0; //si il y a un mur ou pas
		int MurVerticalOuHorizontal; // horizontal ou vertical

		//Calcule le sens de la prochaine etape et la distance entre le joueur et le mur vertical le plus proche en fonction de la prochaine etape x
		if (RayonDirX < 0) //gauche
		{
			EtapeX = -1;
			DistanceMurX = (RayonPosX - MapX) * Distance2MurX; //distance entre joueur et prochain mur
		}
		else //droite
		{
			EtapeX = 1;
			DistanceMurX = (MapX + 1.0 - RayonPosX) * Distance2MurX; //distance entre joueur et prochain mur
		}
		
		//sens de la prochaine etape
		if (RayonDirY < 0)
		{
			EtapeY = -1;
			DistanceMurY = (RayonPosY - MapY) * Distance2MurY;///  On calcule la distance entre le joueur et 1e prochain mur horizontal
		}
		else
		{
			EtapeY = 1;
			DistanceMurY = (MapY + 1.0 - RayonPosY) * Distance2MurY;/// On calcule la distance entre joueur et 1e prochain mur horizontal
		}
		//detection des murs
		while (MurTouche == 0)
		{
			//Saute au prochain carre de la map soit vers la  direction x, soit vers la direction y en fonction du mur le plus proche
			if (DistanceMurX < DistanceMurY)
			{
				DistanceMurX += Distance2MurX;
				MapX += EtapeX;
				MurVerticalOuHorizontal = 0; //Mur vertical
			}
			else
			{
				DistanceMurY += Distance2MurY;
				MapY += EtapeY;
				MurVerticalOuHorizontal = 1; //Mur vertical
			}
			//Verifier si le rayon a detecte un mur
			if (map[MapX][MapY] > 0) MurTouche = 1;
		}




		//Calcul de la distance projetée sur la direction de la camera (La distance oblique donnera un effet fisheye !)
		if (MurVerticalOuHorizontal == 0)
		LongueurMur = fabs((MapX - RayonPosX + (1 - EtapeX) / 2) / RayonDirX);
		else
		LongueurMur = fabs((MapY - RayonPosY + (1 - etapeY) / 2) / RayonDirY);

		//hauteur de la ligne appelee a l'ecran
		HauteurMur = abs(int(hauteur / LongueurMur));

		//calcul coordonnées pixels
		DrawStart = - HauteurMur / 2 + hauteur / 2;
		if(DrawStart < 0) DrawStart = 0;
		DrawEnd = HauteurMur / 2 + hauteur / 2;
		if(DrawEnd >= h) DrawEnd = hauteur - 1;


		Color=ML_WHITE
		if (MurVerticalOuHorizontal == 1)Color=ML_BLACK;

	
		ML_vertical_line(x, DrawStart, DrawEnd, Color);
		ML_pixel(x, DrawStart,ML_BLACK);
		ML_pixel(x, DrawEnd,ML_BLACK);
    }
}
